/*******************************************************************
 * 							 Pilot Software
 *
 *	Copyright (c) 1994-1997, Palm Computing Inc., All Rights Reserved
 *
 *-------------------------------------------------------------------  
 * FileName:
 *		Pilot.h
 *
 * Description:
 *		Include file used by UI library source code modules
 *
 * History:
 *   	6/ 6/95  RM - Created by Ron Marianetti
 *		2/24/97  RF - Changed to handle c++ versions.
 *   	4/24/97  SL - Changes for PalmOS 2.0 SDK
 *   	5/19/97  SL - Now includes <types.h> only in MWERKS environments
 *
 *******************************************************************/  


// This tells "SysAll.h" not to use it's own pre-compiled header
#define	__PILOT_H__ 

// Include the pre-compiled header, if not overriden. This pre-compiled header
//  can be automatically re-generated by CodeWarrior by including the
//  source file "Pilot.pch" in your project.
#ifndef PILOT_PRECOMPILED_HEADERS_OFF

	// Use Metrowerk's precompiled headers option
	#if defined(__MWERKS__)
		#if	!__option(precompile)
			#if	__PALMOS_TRAPS__
				#ifdef __cplusplus
					#include "Pilot.h++.mch"
				#else
					#include "Pilot.h.mch"
				#endif
			#else
				#ifdef CMD_LINE_BUILD			
					#ifdef __cplusplus
						#include "Pilot.h++.mpw.mch"
					#else
						#include "Pilot.h.mpw.mch"
					#endif
				#else	
					#ifdef __cplusplus
						#include "Pilot.h++.sim.mch"
					#else
						#include "Pilot.h.sim.mch"
					#endif
				#endif
			#endif
			#define	__INCLUDED_PILOT_H_OBJ__
		#endif
	#endif
	
#endif


// Fastest compilation speed is obtained by not including these
//  headers when the pre-compiled header is used.
#ifndef __INCLUDED_PILOT_H_OBJ__

// The following Mac include file must be included before the Pilot
//  headers for the emulator modules that have both Mac and Pilot
//  code in them.  This is only relevant for development environments
//  that can compile both Mac and PalmOS code.
#if defined(__MWERKS__)
	#if !defined(CMD_LINE_BUILD) && !defined(__PALMOS_TRAPS__)
		#include <types.h>		// Include Mac types.h file
	#endif
#endif


#include <SysAll.h>
#include <UIAll.h>

#define	NON_PORTABLE
#include <Globals.h>
#include <UIGlobals.h>

#endif
